# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2011 Yiannis Tsagatakis (talos) jtsagata@jmail.com
# 
# gttkTree is written by: Paul Pogonyshev <pogonyshev@gmx.net>
# We include it here for easy installation
# 
# Graphviz interface is written by: 
# Tomás Vírseda, Jose Fonseca
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import gtk

from thistle_tales.helpers import get_builder

import gettext
from gettext import gettext as _
gettext.textdomain('thistle-tales')

class AboutThistleTalesDialog(gtk.AboutDialog):
    __gtype_name__ = "AboutThistleTalesDialog"

    def __new__(cls):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated AboutThistleTalesDialog object.
        """
        builder = get_builder('AboutThistleTalesDialog')
        new_object = builder.get_object("about_thistle_tales_dialog")
        new_object.finish_initializing(builder)
        return new_object

    def finish_initializing(self, builder):
        """Called while initializing this instance in __new__

        finish_initalizing should be called after parsing the ui definition
        and creating a AboutThistleTalesDialog object with it in order to
        finish initializing the start of the new AboutThistleTalesDialog
        instance.
        
        Put your initialization code in here and leave __init__ undefined.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.ui = builder.get_ui(self)

        # Code for other initialization actions should be added here.


if __name__ == "__main__":
    dialog = AboutThistleTalesDialog()
    dialog.show()
    gtk.main()
