#!/usr/bin/python
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2011 Yiannis Tsagatakis (talos) jtsagata@jmail.com
# 
# gttkTree is written by: Paul Pogonyshev <pogonyshev@gmx.net>
# We include it here for easy installation
# 
# Graphviz interface is written by: 
# Tomás Vírseda, Jose Fonseca
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

"""Code to add AppIndicator."""

import gtk

from helpers import get_media_file

import gettext
from gettext import gettext as _
gettext.textdomain('thistle-tales')

import appindicator

class Indicator:
    def __init__(self,window):
        self.indicator = appindicator.Indicator('thistle-tales','applications-games',appindicator.CATEGORY_APPLICATION_STATUS)
        self.indicator.set_status(appindicator.STATUS_ACTIVE)
    
        #Can use self.icon once appindicator python api supports custom icons.
        icon = get_media_file("logo.png")
        #self.indicator.set_icon(icon)
 
        #Uncomment and choose an icon for attention state. 
        #self.indicator.set_attention_icon("ICON-NAME")
        
        self.menu = gtk.Menu()

        # Add items to Menu and connect signals. 
        # Can access methods from bin/python_name using window
        
        #Adding preferences button 
        #window represents the main Window object of your app
        #self.preferences = gtk.MenuItem("Preferences")
        #self.preferences_dialog.connect("activate",window.preferences)
        #self.preferences.show()
        #self.menu.append(self.preferences)

        self.quit = gtk.MenuItem("Quit")
        self.quit.connect("activate",window.on_destroy)
        self.quit.show()
        self.menu.append(self.quit)

        # Add more items here                           

        self.menu.show()
        self.indicator.set_menu(self.menu)
    
def new_application_indicator(window):
    ind = Indicator(window)
    return ind.indicator
