# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
import gtk,sys
import thistle_tales.helpers as helpers
from thistle_tales.gtktree.model import RowObjectListStore

#try:
#    from gtktree.model import RowObjectListStore
#except ImportError:
#    sys.excepthook (*sys.exc_info ())
#    sys.exit ("Please build Py-gtktree by executing 'python setup.py build' in the py-gtk tree directory first")


class InvalidConversionCode(Exception):
    def __init__(self, value):
        self.parameter = value
    def __str__(self):
        return repr(self.parameter)
    
_Conversions = {}
class Conversion:
    """ Class represent a thiste conversion """
    WHEN_HIDDEN = 0
    WHEN_ALWAYS = 1
    WHEN_DAY    = 2
    WHEN_NIGHT  = 3
    
    MATERIALS = ['Pot','Nit','H20','Oxy','Sun','Asc','Bio','Car','Fol','Nia','Pyr','Thi']
        
    def __init__(self, name, active=True,notes=""):
        #TODO check if is in list 
        if name in _Conversions_names:
            id = [k for k,v in _Conversions.iteritems() if v[0]==name][0]
            self.id=id
            self.active = active
            self.notes=notes
        else:
            raise InvalidConversionCode(name)

    def __repr__(self):
        return "<Conversion '%s': %s (%s) Active %s>" % (self.name, self.description, self.when, self.active) 
    
    @property
    def name(self):
        return _Conversions[self.id][0] 

    @property
    def description(self):
        return _Conversions[self.id][1] 
    
    @property 
    def when_txt(self):
        return _Conversions[self.id][2]

    @property 
    def klass(self):
        return _Conversions[self.id][3]

    @property 
    def gets(self):
        return _Conversions[self.id][6]
    
    @property 
    def gives(self):
        return _Conversions[self.id][7]

    @property 
    def outval(self):
        return _Conversions[self.id][8]


class VoidsModel(RowObjectListStore):
    def __init__(self):
        _fields = [
            (str, 'name'),(bool,'active'),(str,'when_txt'),(str,'description'),(str,'notes'),(int,'klass'),
            (str,'gets'),(str,'gives'),(str,'outval')
        ]
        _values = [Conversion(v[0]) for v in _Conversions.values()]
        RowObjectListStore.__init__(self,_fields,_values)
        self.dirty = False
    def read_from_file(self):
        # TODO: Read voids from string of file buffer
        pass
    
""" Read _Conversions from file """
def get_voids_definitions():
    #print "Read voids from file ..."
    fn = helpers.get_data_file("thistle","convos.txt")
    fin = file(fn, 'r')
    
    order = 0
    for line in fin:
        l = line.strip()
        if len(l) > 0 and not l.startswith('#'):
            fields = [x.strip() for x in line.split(' ') if len(x.strip()) > 0]
            
            inVal = fields[0]
            inMat = fields[1]
            if inMat not in Conversion.MATERIALS:
                print "%s is not an Indegrient name. Valid names are:" % inMat
                print Conversion.MATERIALS
                raise SystemExit
        
            if fields[2] == "Always":
                id = "%s(-)" % fields[1]
                txt = "Remove %s" % (inMat)
                when = "Always"
                klass = Conversion.WHEN_HIDDEN
                outVal = multi = conVal = 0
                get = None
                give = None
            else:
                outVal = fields[2]
                outMat = fields[3]
                #inType = 
                multi = {">":1,"<":-1}[fields[5]]
                id = "%s_%s" % (inMat,outMat)
                conVal = int(fields[6])
                txt ="%s %s -> %s %s" % (fields[0],fields[1],fields[2],fields[3])
                when = "%s %s %s" % (fields[4],fields[5],fields[6])
                get = fields[1]
                give = fields[3]
                if fields[4] == "Sun":
                    if multi == -1 and conVal < 33:
                        klass = Conversion.WHEN_NIGHT
                    else:
                        klass = Conversion.WHEN_DAY
                else:
                    klass = Conversion.WHEN_ALWAYS
            order += 1
            #_Conversions[order] = (id,txt,when,klass,inType,outType,inVal,outVal,condType,multi,contValue)
            _Conversions[order] = (id,txt,when,klass,multi,conVal,get,give,outVal)

get_voids_definitions()
_Conversions_names = [v[0] for k,v in _Conversions.iteritems()]
#for v in _Conversions.values():
#    print v
#print _Conversions